/*
 *  icons.c:		Some nice XPM icons
 *
 *  Written by:		Ullrich Hafner
 *		
 *  This file is part of FIASCO (Fractal Image And Sequence COdec)
 *  Copyright (C) 1994-2000 Ullrich Hafner <hafner@bigfoot.de>
 */

/*
 *  $Date: 2000/07/04 16:27:45 $
 *  $Author: hafner $
 *  $Revision: 4.1 $
 *  $State: Exp $
 */

#include <stdio.h>

#include "config.h"

#include "misc.h"
#include "icons.h"

#include "error.h"

/****************************************************************************

			     local variables
  
*****************************************************************************/

/* XPM */
static char * undo_cap_up_xpm[] = {
"33 33 88 1",
" 	c #888888888888",
".	c #777788888888",
"X	c #888899998888",
"o	c #888888889999",
"O	c #999988889999",
"+	c #888899999999",
"@	c #999999999999",
"#	c #99999999AAAA",
"$	c #9999AAAA9999",
"%	c #AAAAAAAAAAAA",
"&	c #9999AAAAAAAA",
"*	c #AAAABBBBAAAA",
"=	c #888888887777",
"-	c #9D9D83838F8F",
";	c #9F9F99997E7E",
":	c #AAAA99999898",
">	c #AAAA9999AAAA",
",	c #AAAAAAAA9494",
"<	c #BBBBCCCCBBBB",
"1	c #E9E9DDDDE4E4",
"2	c #EEEEEEEEEEEE",
"3	c #AAAAAAAABBBB",
"4	c #DDDDCCCCD8D8",
"5	c #FFFFFFFFFFFF",
"6	c #888877779999",
"7	c #111111111111",
"8	c #111100001111",
"9	c #444444444444",
"0	c #444444444E4E",
"q	c #44444D4D3C3C",
"w	c #555555555555",
"e	c #444455555858",
"r	c #CCCCCCCCCCCC",
"t	c #666666668888",
"y	c #444444446666",
"u	c #111111112222",
"i	c #000000001111",
"p	c #666677777777",
"a	c #DDDDDDDDDDDD",
"s	c #F3F3D7D7D9D9",
"d	c #444433336666",
"f	c #1A1A22221818",
"g	c #000000000000",
"h	c #888877778888",
"j	c #777788887777",
"k	c #CCCCDDDDC9C9",
"l	c #AAAA9999BBBB",
"z	c #44444C4C8686",
"x	c #212133334343",
"c	c #333333333333",
"v	c #666666666666",
"b	c #626277775E5E",
"n	c #777766667777",
"m	c #BBBBAAAABBBB",
"M	c #CCCCBBBBCCCC",
"N	c #313139395555",
"B	c #111100000000",
"V	c #555555556666",
"C	c #666666667777",
"Z	c #25250D0D1919",
"A	c #A3A3B6B6C3C3",
"S	c #1B1B1A1A4343",
"D	c #222222223333",
"F	c #BBBBBBBBBBBB",
"G	c #777777777777",
"H	c #000011111111",
"J	c #C8C8D9D9C5C5",
"K	c #9C9C6E6E6F6F",
"L	c #222233333333",
"P	c #D9D9EEEEE0E0",
"I	c #BBBBBBBBCCCC",
"U	c #FFFFF6F6F6F6",
"Y	c #CCCCBBBBBBBB",
"T	c #555543435555",
"R	c #333333334444",
"E	c #99998888AAAA",
"W	c #333344444444",
"Q	c #222222222222",
"!	c #777777778888",
"~	c #555555557777",
"^	c #000011110000",
"/	c #333322224444",
"(	c #333322223333",
")	c #CDCDCDCDCBCB",
"_	c #BBBBCCCCCCCC",
"`	c #BBBBAAAAAAAA",
"'	c #666655556666",
"]	c #BABABBBBA9A9",
" . X XoXOXO+@+@@@@#$#$#$%$%&%&%*%",
"=- - - OXO;O;O@@@:@:$:$>$>,%,%%%%",
"oXoXoXOXO+@+@@@@#$>$#$>$>&%<121%3",
"   - OXO;O;O@@@:@>$:$>$>,4513678%",
" XoX99999999990q0q0qwqwer2tyyuipO",
" - O94a4a4a4asasasasasa15oydfgwhj",
"oXOX9k@+@@@@#$>$#$>$>&r5lyzxgcvbn",
" OXO94;O@@@:@>$:$>$>,m5MydNB7vvn ",
"OXO+9k@@@@#$#$#$%$%&%21yyyu7Vvv %",
"XO;O94@@@:@:$:$>$>,%<5CdyZgVvv=O,",
"O+@+9k@@#$>$#$>$>&%A5AzySgDjvp@&F",
";O;O94@:@>$:$>$>,%%1adyNguchGO,mF",
"@+@@9k#$#$#$%$%&%&M5tydH7wcX &%FF",
";O@@9sr2JK$>$>,%,m5mydu8qwc>,>FFF",
"@@@@@5a+yLh$>&%%%P1yzxgLwv9r%FFFI",
"@@@mU4ydyDbO,%%%<5CdNi7vvnw4FFFYF",
"@@#kryzyyyu.@&%A5Azy7HVvG wPFFI<I",
"@:@4VdydydDT=@%1adyDgTvv=Ow1FYFY<",
"#$>$R&zyzyN7G M5tydgDvvp@%wPI<I<I",
"@>$: 4ydydyZ9O5myd78vvG %Fw1FYFYF",
"#$#$waEyyyzxcP1yyDgWvv @FFVPI<I<M",
"$:$>q4rdydyde5tdNBQvvn@%FYw1<Y<M<",
"#$>$TPM!zyzyz~zyu^VvG %FI<VPI<M<M",
"$>$>w1%rydydydy/g(vv %FYFYw1FM<M)",
"%$%&wP%atyzyyyd^uvvG@%I<I<VPM<r_r",
"$>,%w1%`FdydydD8wvG %`FY<Yw1<M)r)",
">&%%wGwwFtzyzNg7Qc9wVwVwVw'PM_r_r",
",%%%%1a123ydNu^h O)4a1a1a1P1)M)Mr",
"%&%*%*3*m igg^Rwv 3*I<I<M<r_r_rrr",
",%%%%`%m*>,hGvvv :FY<Y<M<M)r)rrrr",
"%%%%3*m*mA%+ GG o*I<I<M<M_r_rrrrr",
"%%%`%m*m]m]>%@@:%`FYFM<M)M)Mrrr4r",
"%*3*m*mAFAFFF%3*I<I<M<r_r_rrrkrkr"};

/* XPM */
static char * bibtex_xpm[] = {
"33 33 94 2",
"  	c #888877778888",
". 	c #888888888888",
"X 	c #9D9D83838F8F",
"o 	c #999988889999",
"O 	c #888899998888",
"+ 	c #BBBBAAAABBBB",
"@ 	c #BABABBBBA9A9",
"# 	c #BBBBAAAAAAAA",
"$ 	c #AAAABBBBAAAA",
"% 	c #AAAAAAAA9494",
"& 	c #999999999999",
"* 	c #AAAA99999898",
"= 	c #AAAA9999AAAA",
"- 	c #9999AAAA9999",
"; 	c #AAAAAAAAAAAA",
": 	c #777788888888",
"> 	c #888888889999",
", 	c #888899999999",
"< 	c #CCCCBBBBCCCC",
"1 	c #C8C8D9D9C5C5",
"2 	c #FFFFFFFFFFFF",
"3 	c #CCCCDDDDC9C9",
"4 	c #DDDDCCCCD8D8",
"5 	c #99999999AAAA",
"6 	c #9999AAAAAAAA",
"7 	c #888888887777",
"8 	c #CCCCCCCCCCCC",
"9 	c #EEEEEEEEEEEE",
"0 	c #666677777777",
"q 	c #444433334444",
"w 	c #0F0F22220F0F",
"e 	c #000000000000",
"r 	c #25250D0D1919",
"t 	c #444444444444",
"y 	c #E3E3F3F3E9E9",
"u 	c #BBBBBBBBCCCC",
"i 	c #A3A3B6B6C3C3",
"p 	c #333344444444",
"a 	c #1A1A22221818",
"s 	c #555543435555",
"d 	c #555566666666",
"f 	c #79797777A7A7",
"g 	c #777788887777",
"h 	c #272733332222",
"j 	c #111100000000",
"k 	c #333333333333",
"l 	c #666666666666",
"z 	c #777766667777",
"x 	c #777777777777",
"c 	c #666666667777",
"v 	c #626277775E5E",
"b 	c #777777778888",
"n 	c #AAAAAAAABBBB",
"m 	c #555555555555",
"M 	c #33333E3E2525",
"N 	c #888874746A6A",
"B 	c #84849595B8B8",
"V 	c #333322223333",
"C 	c #ECECF8F8FBFB",
"Z 	c #444466666666",
"A 	c #444455555858",
"S 	c #111100001111",
"D 	c #FFFFF6F6F6F6",
"F 	c #44444D4D3C3C",
"G 	c #000011110000",
"H 	c #333333334444",
"J 	c #222233333333",
"K 	c #BBBBBBBBBBBB",
"L 	c #444444444E4E",
"P 	c #707082828484",
"I 	c #676766665050",
"U 	c #666655556666",
"Y 	c #AEAE41414949",
"T 	c #8C8C61614141",
"R 	c #9C9C6E6E6F6F",
"E 	c #AAAA11111111",
"W 	c #8F8F0C0C0F0F",
"Q 	c #898955555757",
"! 	c #FFFF34345656",
"~ 	c #7C7C28281212",
"^ 	c #CCCCBBBBBBBB",
"/ 	c #E8E839394141",
"( 	c #434306060505",
") 	c #BBBBCCCCBBBB",
"_ 	c #333322222222",
"` 	c #999911112222",
"' 	c #F6F693939595",
"] 	c #FFFF4A4A6F6F",
"[ 	c #5A5A30301818",
"{ 	c #AAAA00002222",
"} 	c #BBBBCCCCCCCC",
"| 	c #1C1C0F0F0808",
" .	c #222222222222",
"..	c #9F9F99997E7E",
"  . . . . . . . X . o O + @ # $ + % & & * & = - * - = - = % ; ; ; ",
": . : . O . O > , < 1 2 2 2 2 2 2 2 3 4 O 5 - 5 - ; - ; 6 ; 6 ; $ ",
". 7 X . X . X 8 2 2 9 3 5 0 q w e e r t * - * - = - = % ; % ; ; ; ",
". > O > O > 2 2 y u i , p e a s d f g o O 5 - = - = 6 ; ; ; ; ; ; ",
". . . . X 2 2 6 5 6 6 h j k s l z x   g X - = - = % ; ; ; ; ; ; # ",
"O . O > 0 2 6 6 6 6 g e h l l c v b g b O ; - ; 6 ; 6 ; $ ; $ n $ ",
"X . X . m , 5 6 6 6 b M t l N x N g N O o - = % ; % ; ; ; ; # ; + ",
"O > O   m > 6 6 6 6 6 c d b g o O > - = - = 6 ; ; ; ; ; ; n $ + $ ",
"X . o m 5 9 b , 5 6 B d V . o - * - = - = % ; ; ; ; ; ; # ; + $ + ",
"O m m B C b Z A Z b d S 6 m - 5 - ; - ; 6 ; 6 ; $ ; $ n $ + $ + i ",
"e 9 D 9 b F e h V G S : 2 6 m - = - = % ; % ; ; ; ; # ; + $ + @ + ",
"e   C i Z e k l m H e J : 2 6 m - = 6 ; ; ; ; ; ; n $ + $ + i K i ",
"q e l , L e l l l l s e V : 2 6 m % ; ; ; ; ; ; # ; + $ + @ + @ + ",
"0 k e k e k l c v c l l e J P 2 6 m v ; $ ; $ n $ + $ + i K i K K ",
"z I V e V l N x N g z l U e V : 2 6 Y T ; ; # ; + $ + @ + @ + K K ",
"0 l l l l c g o O > g z l l e J d R E W Q n $ + $ + i K i K K K K ",
"  x l l z x o - * - o g z x l e r W ! E W ~ + $ + @ + @ + K K K ^ ",
". . x b g b O 5 - ; - & : x l U e r ~ / E W ( + i K i K K K K u ) ",
"& & X . X O * - = - = % & 7 x x _ e ( ` ! / W ( + @ + K K K ^ K ^ ",
"& 5 - = - 5 - = - = 6 ; ; & . x l V e ~ E ' / W ( K K K K u ) u ) ",
"* & = - * - = - = % ; ; ; ; & . N l r ( ] [ ! E W ( K K ^ K ^ K ^ ",
"- 5 - 5 - ; - ; 6 ; 6 ; $ ; $ 5 .   v S ( j / ' / W ( u ) u ) u ) ",
"* - * - = - = % ; % ; ; ; ; # ; = . z x j j ] [ ! E W ( ^ ) ^ ) < ",
"- 5 - = - = 6 ; ; ; ; ; ; n $ + - o . x 0 S ( r / ' / W ( u ) < ) ",
"* - = - = % ; ; ; ; ; ; # ; + $ + @ o . z x j j ] [ ! E W ( < ) < ",
"- ; - ; 6 ; 6 ; $ ; $ n $ + $ + i K 6 & . x x S ( r / ' / { ( 8 } ",
"= - = % ; % ; ; ; ; # ; + $ + @ + @ + ; & . N x j j ] [ ! E W ( 8 ",
"- = 6 ; ; ; ; ; ; n $ + $ + i K i K K K ; 5 . b g S ( r ~ ! / W ( ",
"= % ; ; ; ; ; ; # ; + $ + @ + @ + K K K ^ ; * . N x j j j W { j q ",
"6 ; 6 ; $ ; $ n $ + $ + i K i K K K K u ) u $ 5 .   g S | r |  .; ",
"; % ; ; ; ; # ; + $ + @ + @ + K K K ^ K ^ ) ^ $ = O   7 j j r . & ",
"; ; ; ; ; n $ + $ + i K i K K K K u ) u ) u ) < $ = . . : . . . & ",
"; ; ; ; # ; + $ + @ + @ + K K K ^ K ^ K ^ K < ) < @ = ..  . . & # "};


/* XPM */
static char *info_prev_xpm[] = {
/* width height num_colors chars_per_pixel */
"    33    33       83            2",
/* colors */
".. c #b0b4b0",
".# c #b8b4b8",
".a c #b0b0b0",
".b c #a8aca8",
".c c #a8a8a8",
".d c #a0a4a0",
".e c #a8a4a8",
".f c #a0a0a0",
".g c #989c98",
".h c #a09ca0",
".i c #909490",
".j c #b8b8b8",
".k c #989498",
".l c #b8bcb8",
".m c #989898",
".n c #b0acb0",
".o c #c0c0c0",
".p c #b0b4b8",
".q c #a8acb0",
".r c #909498",
".s c #989ca0",
".t c #c0c4c0",
".u c #b0b0b8",
".v c #a8a8b0",
".w c #787878",
".x c #707478",
".y c #505458",
".z c #a0a4a8",
".A c #c0c0b8",
".B c #b8bcc0",
".C c #c0c0c8",
".D c #c0bcc0",
".E c #9898a0",
".F c #808488",
".G c #707070",
".H c #808088",
".I c #787880",
".J c #585858",
".K c #a0a0a8",
".L c #c0c4c8",
".M c #b8b8c0",
".N c #888890",
".O c #808090",
".P c #787888",
".Q c #9894a0",
".R c #606060",
".S c #807c80",
".T c #808080",
".U c #888c90",
".V c #989ca8",
".W c #a09ca8",
".X c #909090",
".Y c #606068",
".Z c #c8c4c8",
".0 c #908c90",
".1 c #909098",
".2 c #888888",
".3 c #9090a0",
".4 c #c8c8c0",
".5 c #787c78",
".6 c #888c88",
".7 c #9094a0",
".8 c #908c98",
".9 c #c8c8c8",
"#. c #c8ccc8",
"## c #d0d0d0",
"#a c #888c98",
"#b c #c8ccd0",
"#c c #606468",
"#d c #d8d8d8",
"#e c #888490",
"#f c #888488",
"#g c #686468",
"#h c #d0d0d8",
"#i c #a8a4b0",
"#j c #787c80",
"#k c #c8c8d0",
"#l c #c8ccd8",
"#m c #d0ccd8",
"#n c #706c70",
"#o c #d8dce0",
"#p c #d0d4d0",
"#q c #d0ccd0",
/* pixels */
".......#.................n.n.n.n.c.c.c.c.c.c.c.d.c.c.c.h.h.h.h.h.g",
".....#.#...#...........a.a.n.b.n.b.c.c.c.d.d.d.d.c.d.c.h.h.h.h.h.h",
"...#.j.j...#.#...#.......a...n.n.n.n.c.c.c.c.d.c.h.c.d.c.h.h.d.h.g",
".....j.j...#...............n.n.a.b.n.b.c.c.c.c.c.c.h.c.h.c.d.c.d.h",
".j.j.j.j.#...#.#.#...............a.a.n.n.b.c.b.c.h.h.h.d.c.h.d.c.h",
".j.o.o.j.j.j.#.....#.............a.n.n.b.n.n.n.c.h.h.h.c.c.d.k.c.h",
".o.j.o.j.#.#.#.#...#.....#...#.....n.n.n.b.n.n.d.k.k.h.c.c.c.k.d.d",
".o.o.o.j.#.j.#.#.#.......M.#.........a.q.q.c.k.X.I.k.d.c.c.h.g.c.f",
".o.o.o.j.j.j.j.....#...a...M.M.M.M.a.q.c.f.X.I.I.J.k.q.n.c.f.d.d.d",
".o.o.o.j.t.j.j.o.o.....a.M.o.o.o.M.a.V.N.I.I.H.I.R.k.q.q.c.d.d.d#i",
".o.o.o.o.t.j.j.o.D.o.o.M.D.o.u#i.f.N.O.O.P.H.X.O.R.k.q.q.c.W.W#i.d",
".o.o.t.o.j.j.j.j.o.o.D.o.u.v.f.N.I.H.H.X.Q.V.X.N#c.k.n.c.c.c.c.c.c",
".9.o.t.j.j.j.j.o.o.j.j.q.k.X.N.O.X.N.1.Q.f.V.V.1#g.k.v.c.c.d#i.c.c",
".o.o.o.j.t.o.o.o.j.q.d.k.O.O.N.X.k.Q.V.V.V.V.k.X#g.k.q.v.c#i.c.c.c",
".9.o.o.j.o.o.o...n.k.X.O.N.X.1.k.Q.k.Q.1.1.1.k.X#c.k.q.q.c.c.v.c.c",
".o.o.o.o.o.j...d.X.O.O.N.k.k.r.k.k.k.r.Q.k.k.r.N#n.Q.q.q.n.c.c.c.c",
".o.o.o.4.o...d.N.S.S.N.h.k.X.X.k.k.Q.Q.r.3.1.1.N#g.k.q.a#i.c.c.v.v",
".9.o.4.4##.4##.j...c.k.O.k.k.r.1.X.N.X.O.1.Q.k.k#c.d.#...a.c.c#i.q",
".o.9.4.4####.4.9.o.j...q.f.X.X.X.X.Q.Q.Q.X.O.k.X#g.f.M.#...a.q.a.q",
".Z.Z.4.o.4.4##.o##.o#k.o.M.c.Q.X.X.3.k.1.X.X.X.O#n.V.a.M.a.M...q.a",
".Z.o##.o.4.o.o.o.o###k##.Z.o..#i.Q.X.X.X#a.N.O.O#g.f.....q.a.M.q.q",
".o.4.4##.o.Z.o.D.o.o.D.o#h#h##.o.q#i.Q.O.N.N.H.O#g.c...u.q.v.a.a.a",
".9.o##.Z.4.4.o.o.o.o.o.M.o.o#####h#k.a.W.X.O.H.N#g.d.M.a.a.q.q.a.a",
".4##.4##########.4##.o.D.D.D.C#k###h##.C.u.d.N.N#n.f.M.M...M.j.M.q",
"##.4##.o##.4#####b.Z##.o#k.o.o.M.M#k#k#h#l.D.q.c.x.d.a.M...M.M...a",
".4##.9.4.4.4.Z.o.9.o.o#k.o#l.D.o.o.o#k.C#k#l#l.#.H.c.q...a.M...M.a",
"##.4######.4.4##.o##.o##.o.o#k.o.o.D.o.o.D.o##.D.c...M...#........",
"#d##.4########.9.4###l.o#l.o.Z.o.o.o.o.o.o.D.o.o.o.o.j.M.#.....M..",
"#d#d##.4####.9.4##.o.4.4.Z.4.Z.Z.o.o.o.o.j.o.o.o.o.o.j.j.#.....o..",
"#d.4###d.4####.4######.Z##.o.o.9.o.o.D.o.o.o.o.o.o.j.j.j.j...M.#..",
"#d#d##.4#d.4###h.4##.4##.Z##.4##.o.o.o.o.t.D.o.o.o.o.o.j.j.j...#.#",
"#d#d#h#h.4#d.4####.4##.9.4####.Z##.o.9.o.o.o.o.o.o.o.j.o.j.j.j.j.j",
"#d#d.4#d###h#d.4####.4####.4##.4##.o.4.o.o.o.o.o.o.o.o.j.D.j.j.j.#"
};
/* XPM */
static char *info_next_xpm[] = {
/* width height num_colors chars_per_pixel */
"    33    33       77            2",
/* colors */
".. c #949694",
".# c #a49ea4",
".a c #9c9e9c",
".b c #a4a2a4",
".c c #a4a6a4",
".d c #aca6ac",
".e c #acaaac",
".f c #acaeac",
".g c #b4aeb4",
".h c #b4b2b4",
".i c #b4b6b4",
".j c #bcb6bc",
".k c #9c9a9c",
".l c #bcbabc",
".m c #bcbebc",
".n c #c4c2c4",
".o c #a4a6ac",
".p c #9c969c",
".q c #94969c",
".r c #acaeb4",
".s c #b4b6bc",
".t c #54565c",
".u c #74767c",
".v c #7c7a84",
".w c #acaab4",
".x c #b4b2bc",
".y c #c4c6c4",
".z c #a4a2ac",
".A c #9c9ea4",
".B c #5c5a5c",
".C c #7c7e84",
".D c #847e8c",
".E c #747274",
".F c #84828c",
".G c #9c9aa4",
".H c #c4bec4",
".I c #c4c2cc",
".J c #bcbec4",
".K c #c4c2bc",
".L c #8c8a94",
".M c #7c7a8c",
".N c #bcbac4",
".O c #c4c6cc",
".P c #64626c",
".Q c #8c8e94",
".R c #9496a4",
".S c #646264",
".T c #948e94",
".U c #a49eac",
".V c #9c9eac",
".W c #848284",
".X c #94929c",
".Y c #8c8a8c",
".Z c #84868c",
".0 c #949294",
".1 c #cccac4",
".2 c #948e9c",
".3 c #8c868c",
".4 c #7c7a7c",
".5 c #7c7e7c",
".6 c #8c8694",
".7 c #8c8e9c",
".8 c #cccacc",
".9 c #d4d2d4",
"#. c #cccecc",
"## c #ccc6cc",
"#a c #ccced4",
"#b c #64666c",
"#c c #d4d2dc",
"#d c #dcdadc",
"#e c #d4d6d4",
"#f c #cccad4",
"#g c #cccedc",
"#h c #746e74",
"#i c #d4cedc",
"#j c #dcdee4",
"#k c #d4ced4",
/* pixels */
".....#.a.a.b.a.a.c.b.b.b.c.d.d.c.e.f.f.f.f.g.h.i.h.i.i.i.j.i.j.i.i",
".....#.a.a.b.a.a.c.b.b.b.c.d.d.c.e.f.f.f.f.g.h.i.h.i.i.i.j.i.j.i.i",
".k.k.a.b.b.b.c.c.c.c.c.c.d.c.c.e.e.f.f.h.h.f.h.h.h.i.i.i.i.i.l.m.i",
".k.k.c.c.b.a.b.b.c.d.c.e.c.e.e.e.f.g.h.h.h.i.i.h.i.i.j.j.l.l.i.m.l",
".a.a.c.a.c.c.c.c.a.b.c.f.e.f.f.f.f.f.h.i.i.h.i.i.i.i.l.l.i.l.l.n.l",
".a.a.d.a.b.e.c.c.k.k.b.f.f.f.f.g.h.h.i.i.i.i.i.j.i.l.i.i.l.l.i.n.m",
".b.b.o.p.o.f.c.c.q...c.h.f.r.r.f.r.h.i.i.i.j.s.i.j.i.l.l.l.l.m.n.m",
".b.b.o.p.o.f.c.c.q...c.h.f.r.r.f.r.h.i.i.i.j.s.i.j.i.l.l.l.l.m.n.m",
".b.b.o.#.b.d.g.g.e.t.u.v.w.g.g.x.x.s.s.j.j.s.g.h.i.s.l.l.i.m.l.y.n",
".z.z.o.A.z.o.r.r.w.B.C.D.E.F.F.G.x.H.I.J.J.l.r.h.s.m.m.m.m.m.K.n.y",
".c.c.o.d.c.o.r.r.e.B.F.L.v.M.M.F.L.G.r.N.N.O.j.J.n.J.m.m.m.K.y.n.y",
".o.o.d.o.o.d.w.w.w.P.Q.q.z.R.R.F.v.v.L.#.#.r.J.n.y.n.l.l.s.l.K.n.y",
".o.o.d.e.o.d.w.w.e.S.T.G.U.V.V.G.q.Q.L.W.W.C.d.r.m.n.n.n.m.m.m.n.y",
".d.d.o.w.d.o.w.w.r.P.Q.G.X.R.R.G.G.G.X.Y.Y.F.Z.0.o.l.y.y.1.y.m.n.y",
".d.d.o.w.d.o.w.w.r.P.Q.G.X.R.R.G.G.G.X.Y.Y.F.Z.0.o.l.y.y.1.y.m.n.y",
".o.o.e.e.o.r.r.r.r.S.Q.X.X.X.X.X.2.X.X.q.q.k.3.F.Y.k.r.r.H.y.y.K.y",
".e.e.w.o.d.e.g.g.r.S.Y.X.X.X.X.R.G.k.q.T.T.Q.#.Q.4.5.....f.n.1.n.y",
".r.r.r.o.w.x.l.l.x.P.0.G.X.2.2.L.6.L.7.q.q.k.Z...e.J.8.8.9#.#.##.y",
".w.w.g.x.h.s.s.s.x.S.L.X.Z.X.X.G.G.X.Q.Q.Q.q.x.l.n.8#.#.#..8.1.8.y",
".g.g.r.j.x.s.j.j.h.P.Z.Q.L.2.2.X.7.L.p.e.e.J.9#a#..8.y.y.8.y.y.8.y",
".g.g.r.j.x.s.j.j.h.P.Z.Q.L.2.2.X.7.L.p.e.e.J.9#a#..8.y.y.8.y.y.8.y",
".r.r.h.r.e.w.s.s.s#b.3.Z.L.Z.Z.6.X.z.N#c#c#d##.O.n.n.n.n.y.1.1.8##",
".r.r.x.r.r.g.s.s.j#b.Z.D.D.7.7.w.I#a#e#f#f.O.N.l.J.n.y.y.O.8.8#..y",
".x.x.h.l.x.s.l.l.s#b.3.Q.o.j.j#g#c#a.I.J.J.J.n.I.8.8#.#.#.#..1#..8",
".r.r.x.N.l.s.s.s.x#h.z.x#g#i#i#g.I.j.s.H.H#f##.O#.#a#.#.#..8.8#..8",
".h.h.h.l.x.h.h.h.j.C.n#j.I.I.I.I.I.I.O.O.O.8.O.O.y.y####.8.1#.#..y",
".i.i.s.i.i.j.l.l.J.n.y.y.J.H.H.m.n.y.O####.y.8.8.8#.#.#.#.#.#k#.#e",
".i.i.s.i.i.j.l.l.J.n.y.y.J.H.H.m.n.y.O####.y.8.8.8#.#.#.#.#.#k#.#e",
".i.i.l.i.i.s.l.l.m.n.n.y.K.m.m.n.n.y##.y.y.8.1#..8.8#.#.#k#a#..9#e",
".i.i.l.i.l.l.m.m.m.n.y.n.J.n.n.K.y.y.y.8.8.8.O#..8#.#.#.#..9#.#k#e",
".i.i.l.l.l.l.m.m.m.n.n.y.n.y.y.n.O.1.8.8.8#.#..8#.#.#k#k#..9#..9#e",
".l.l.l.i.m.m.H.H.m.y.n.y.n.y.y.y##.O#.#.#.#.#.#.#.#k#.#..9.9.9#.#d",
".i.i.m.J.m.K.m.m.n.m.n.n.y####.O.1#.#.#k#k#.#k#.#k#..9.9.9#.#e.9#d"
};

/* XPM */
static char * view_xpm[] = {
"33 33 54 1",
" 	c #868682828686",
".	c #8E8E8A8A8E8E",
"X	c #969692929696",
"o	c #969692929E9E",
"O	c #9E9EA2A2A6A6",
"+	c #AEAEAAAAAEAE",
"@	c #B6B6B2B2BEBE",
"#	c #C7C7C3C3CFCF",
"$	c #CFCFCBCBCFCF",
"%	c #DFDFDFDFE7E7",
"&	c #BEBEBABABEBE",
"*	c #A6A6A2A2AEAE",
"=	c #595955555959",
"-	c #303030303030",
";	c #101010101010",
":	c #303010101010",
">	c #595959595959",
",	c #B6B6B2B2B6B6",
"<	c #BEBEBEBEC7C7",
"1	c #515151515151",
"2	c #202020201818",
"3	c #414141414141",
"4	c #49494D4D5959",
"5	c #38381C1C4141",
"6	c #49493C3C2828",
"7	c #C7C7C3C3C7C7",
"8	c #383838383838",
"9	c #080808080808",
"0	c #616165657171",
"q	c #8E8E82828E8E",
"w	c #86868A8A9696",
"e	c #797979797979",
"r	c #616165656969",
"t	c #616161616161",
"y	c #D7D7D3D3D7D7",
"u	c #616159596161",
"i	c #101014140808",
"p	c #696971717171",
"a	c #38383C3C2020",
"s	c #696969696969",
"d	c #717171717979",
"f	c #08080C0C0808",
"g	c #797982827979",
"h	c #797971712020",
"j	c #CFCFD3D3CFCF",
"k	c #383841414949",
"l	c #494949494949",
"z	c #000000000000",
"x	c #38383C3C4141",
"c	c #BEBEC3C3CFCF",
"v	c #616114145151",
"b	c #616118181010",
"n	c #FFFFFBFBFFFF",
"m	c #DFDFA6A62828",
" . .....X.XXXXXoXXOXOOoOoOOOOOO++",
"......Xo@#$$$%$&+OooOXOOOOOOO++++",
" .....&#*=-;;;:>,&OOoOOOOOO++O+++",
"....X<#1;234>152;67OOOOOOOOO+++++",
"...X<@89100qo*ow69-,OOOOOO++++++,",
"...@#89er*77&&,&7o9-&OOOO+O++++,+",
"..O#19ety%%%7XoXXO@98,OO++++++,+,",
".X@,;1t&%%%y.  e  +t;u++O+++++,+,",
"X.7>i0qy%%%eppp00pp<ia.++++++,+,,",
"XX$:30+%%%,sssssss0O32dO++++,+,,,",
".X$f1d.%y%.spge   eOs;tO++,+,,,,,",
"XX%;4dh%%y,g XooOoo+.;4O++,,,,,,,",
"Xwyf3psyy%%.O+,,&&,7d;=O+,++,,,&,",
"XX#:-rs7%%%7,&7$$77$124o++,,,,,,&",
"XX,4irso%%%%y$$$$$y%28>O+,,,,,&&&",
"oXo+98phy%%y$$$$$jy0;kso+,,,,&,&&",
"XX.,l9d.,%$$$$$$$%$984dO+,,&,&&&&",
"oXXe@-9,77$$$$$yy$9z4t.O,,,,&&&&&",
"XoX.e*:90y$y$yy%09z-r>XO,,&&&&&&&",
"OOXX g+-;i4 o 42;x4zcw>+,&,&&&&&&",
"XOooXggorx2;;;:344r4z#>v,&&&&&&&7",
"OoOOoq e .dt>4>t0dgpz>bnv,&&&&77&",
"oOOOOoXeg  .X.. egdppzbmnv&&&7&77",
"OOOOOOoXqgggg ge  .eppzbmnv&7&777",
"OOOOO++OoXqq   .Xooo ghzbmnv&7&77",
"OOOOOO+O+OOOooOOO+,,o ddzbmnv7777",
"OOO++++++++++,+,,,,,+O ghzbmnv77$",
"OOO+O+++++,+,,,,,&&,&+O ggzbmm977",
"O+O++++++,+,,,,,,,&&&,,Oqggzb9277",
"+O++++++,+,,,,,&&&&&&&&,Oqgg92t&7",
"O++++++,,,,,,,&,&&&&&7&&,+q g o&$",
"++++++,+,,,,,&,&&&&&7&7&7,+. .o&7",
"O++++,+,,,,&,&&&&&&7&77777&+oo,7$"};

/* XPM */
static char * cut_cap_up_xpm[] = {
"33 33 66 1",
" 	c #999999998888",
".	c #999999999999",
"X	c #AAAA99999999",
"o	c #9999AAAA9999",
"O	c #AAAA9999AAAA",
"+	c #999988889999",
"@	c #888899998888",
"#	c #AAAAAAAA9999",
"$	c #AAAAAAAAAAAA",
"%	c #99999999AAAA",
"&	c #BBBBAAAABBBB",
"*	c #9999BBBBAAAA",
"=	c #AAAABBBBAAAA",
"-	c #888888888888",
";	c #BBBBBBBBBBBB",
":	c #444444444444",
">	c #9999AAAAAAAA",
",	c #888888889999",
"<	c #BBBBBBBBAAAA",
"1	c #444455554444",
"2	c #AAAAAAAABBBB",
"3	c #AAAABBBB9999",
"4	c #9999AAAA8888",
"5	c #CCCCBBBBBBBB",
"6	c #888877777777",
"7	c #444466665555",
"8	c #777777777777",
"9	c #BBBBAAAAAAAA",
"0	c #AAAA8888AAAA",
"q	c #777788888888",
"w	c #888899999999",
"e	c #BBBBBBBBCCCC",
"r	c #BBBBCCCCBBBB",
"t	c #777788887777",
"y	c #555555556666",
"u	c #555555554444",
"i	c #999988888888",
"p	c #888877778888",
"a	c #555555555555",
"s	c #666677776666",
"d	c #777766667777",
"f	c #666666667777",
"g	c #999966665555",
"h	c #999966663333",
"j	c #999977775555",
"k	c #888866665555",
"l	c #888844444444",
"z	c #777766665555",
"x	c #999966667777",
"c	c #AAAA88886666",
"v	c #AAAA88887777",
"b	c #AAAABBBBBBBB",
"n	c #BBBB99998888",
"m	c #AAAAAAAA6666",
"M	c #888866666666",
"N	c #666666666666",
"B	c #777766666666",
"V	c #AAAA99996666",
"C	c #BBBBAAAA8888",
"Z	c #CCCCBBBBAAAA",
"A	c #CCCCBBBBCCCC",
"S	c #CCCCCCCCCCCC",
"D	c #CCCCCCCCBBBB",
"F	c #999977778888",
"G	c #CCCCDDDDCCCC",
"H	c #DDDDCCCCCCCC",
" . X.XoOo+@+ + +...X.XoXoOoO#$#$$",
"..+@+o%oOo&*$=-;;;:oOo%oOoO>$$$$$",
".,@..X.OoO$$$$o;;X:OoXoOoO#$$$$$$",
".o+@+oOoO>&>$<-;,1:o%o$o$>$>$=$=2",
".X.X.OoO3+4+...5>678oOoO#$#$$$$9$",
",@+@0@+q.w...@erOtyu8oO>$$$$$$2=&",
"@i-p@+ + +...5;&o+aaap#$$$$$$9$&=",
",@+@+w.w...$2rer2@-sdf8>$=$=2=&=&",
"-+@+ + +...ghgjgkluauzl$$$$9$&=&<",
"+@+w.w....%hxcvcxhlaazg$$$2=&=&b;",
"@+ + +...X.xjxcxgxhzazg$$9$&=&<&<",
"+w.w....%o%hxjvcxggaazg=2=&=&b;b;",
" + +...X.Xon3&3XmvjMNBM9$&=&<&<&;",
".w....%oOo%m9<9#nVcMBzj=&=&b;b;;;",
" +...X.OoXon3XjMkkkMNBM&=&<&<&;;;",
"....%o%o%o$mnzM nckaBBM=&b;b;;;;e",
"...X.XoXoOoXcMkvCvczaBM&<&<&;;;5;",
"..%oOo%oOoO#M9izvVczazjb;b;;;;ere",
".X.OoXoOoO#9zZ<vzvcMaBM&<&;;;5;5;",
"%o%o%o$o$>$#MXZCvzczaBMb;;;;erere",
".XoXoOoO#$##jM<#CjazaBM&;;;5;5r5r",
"Oo%oOoO>$$$CZkMvnckaBzj;;;erererA",
"oXoOoO#$$$$9<5jMkkkMNBM;;5;5;5;Ar",
"%o$o$>$>$=$CZ5ZCnvcMBBM;erererArS",
"oOoO#$#$$$$VC9<#CvcMNBM5;5r5rArAD",
"OoO>$$$$$$2gxcncxggzazMrererArArS",
"oO#$$$$$$9$xcvvvxxgzakg5;5;ArADAD",
"$>$>$=$=2=&gxcvcxggzyzMrerArSrSrS",
"#$#$$$$9$&=ccvcccxkkakz5rArADSDSS",
"$$$$$$2=&=&#9#99nvF8NNy@OrArSrSSS",
"$$$$$9$&=&<+tdNNaNaaN6-+@+<&DASSS",
"$=$=2=&=&b;b;;$.%o%o%o&=;b;rSSSGS",
"$$$9$&=&<&<&;;;5;5r5rArADSDSSSSHS"};

/*******************************************************************************

			       public code
  
*******************************************************************************/

void
init_pixmaps (GtkWidget *window)
/*
 *  Initialize builtin pixmaps.
 *
 *  No return value.
 *
 *  Side effects:
 *	global pixmap array 'p_array' is allocated and filled with all
 *	available pixmaps
 */
{
   char **pmap[] = {undo_cap_up_xpm, bibtex_xpm, info_prev_xpm,
		    info_next_xpm, view_xpm, cut_cap_up_xpm};
   unsigned n;
   
   p_array = Calloc (P_LAST, sizeof (pixmap_t));

   for (n = 0; n < P_LAST; n++)
   {
      p_array [n].pixmap = gdk_pixmap_create_from_xpm_d (window->window,
							 &p_array [n].mask,
							 NULL, pmap [n]);
      gdk_pixmap_ref (p_array [n].pixmap);
      gdk_bitmap_ref (p_array [n].mask);
   }
}

