<WEBPAGE chapter="hsc - " title="How To Reach The Author"
    PREV="copy.html"
    NEXT="changes.html"
    QTEXT=("And I walk<BR>"
         +"Through confusion<BR>"
         +"With a smile on my face")
    QAUTHOR='Ride, "Natural Grace"'>

<P>The main reason why this topic is one of the first, if you are
reading this documentation sequentially, is <EM>not</EM> because I
want to receive as much email as possible. Actually this chapter is
designed to keep my email traffic as low as possible.</P>

<H2>Before You Contact Me</H2>

<P>I know I can't expect you to read the whole manual, but make sure
you have at least read the sections about
<A HREF="questions.html">Questions And Answers</A>,
<A HREF="related.html">Related Stuff</A> (and tools),
<A HREF="future.html">Future improvements</A>
and <A HREF="bugs.html">Known Bugs, Problems And Limitations</A> before
you contact me.</P>

<P>There are also chapters about <A HREF="source.html">compiling</A>
and <A HREF="install.html">installing</A>, and you should at least
give a glimpse at them. For non-Amiga users, there is a chapter about
all those <A HREF="ports.html">existing ports to other systems</A>
describing differences.</P>

<P>Maybe there is already a bugfix available at the <hsc-support>,
so check this, too.</P>

<H2>On What To Contact Me</H2>
If you..
<UL>
<LI>..find any new bugs
<LI>..think that <hsc> accepts severe errors in your sources without
    warning about it (Note the word <EM>severe</EM>)
<LI>..have any questions about <hsc> and it's usage which are not covered
    sufficiently in this documentation or located at a completely
    unexpected place (which should be quite unlikely because I meanwhile
    consider this documentation to be rather useful). Please note that
    I do not want to be bothered by problems concerning tools not included
    in this package, like <make>.
<LI>..want to port <hsc> to another system not yet mentioned on
    <A HREF=":ports.html">Existing ports</A>.
<LI>..have any (reasonable) suggestions how to improve <hsc>; but note that I'm 
    currently not thinking about any conceptional changes.
</UL>
you should contact me.

<H2>On What NOT To Contact Me</H2>

You should not contact me on the following topics:

<UL>
<LI>You just want to say <qq>hi!</qq> and tell me that <hsc> is a
    great tool. 
    <TG>ARROGANCE</TG>I already know that.<TG>/ARROGANCE</TG>.
    Furthermore, I don't think that it is that great as some people
    try to make me believe.
<LI>You want to compile <hsc> for your system but don't have 
    enough experience on such things. Bad luck for you, try to
    increase your circle of acquaintances and find some of these
    unwashed nerds who spend most of their time compiling and
    installing packages like this.
<LI>You think <hsc> is a great program, and you want to use it
    with some MS-DOS-based system like Windows NT, Windows 95
    or OS/2.
<LI>Your compiler has problems compiling a simple ANSI-C program.
    (You won't believe it, but there are still such compilers around.)
<LI>General discussion about html-tags and how to use them. I don't
    know the correct usage of several tags defined in <hsc.prefs>
    myself.
</UL>

If you fail to exclude the above topics from your email, you might
get a reply consisting of a single term: 
<qq>Read the fucking manual!</qq>.

<H2>About Bug Reports</H2>

If you think you've found a bug that is not already mentioned or
discussed in the chapter about <ln_bugs>, you should include some
information in your bug-report:

<UL>
<LI>Which version of <hsc> did you use? You can find this out if you
    invoke <hsc> without any arguments or simply type 
    <qq><CODE>hsc HELP</CODE></qq> in your shell. Always include version number
    and exact date, do not use terms like <qq>the latest version</qq>.
    The CLI option <CODE>HELP</CODE> also exists for all other tools coming
    with this package.
<LI>Under which operating system did you use <hsc>? (e.g. AmigaOS or
    RiscOS)
<LI>Include a single command call or batch-script and hsc source
    (or at least part of) that reproduces the bug.
<LI>Do not send me all your sources for your whole site, try to trace
    the bug back to a single input-file and macro, if possible.
</UL>

<P>Exceptions of these are <A HREF="bugs.html#internal">internal error
messages</A>, as they usually leave you without a glue. Try to include
the information described above as long as it does not require any
effort, read: program version and name of system.</P>

<P>You don't have to provide information about the exact hardware or
version of the operating system or compiler used, as <hsc> is supposed
to be rather system independent, but I might asked you for that in a
reply, so keep this at hand.<P>

<P>The more specific and smaller your bug-report is, the more likely
I might fix it; although  I can't promise that I will fix all bugs
reported to me in reasonable time.</P>

<P>If your bug-report fails to include the above informations, I might
completely ignore it.</P>

<H2>...And Finally</H2>

<P>You can reach me via email using <EMAIL ADDRESS="agi@giga.or.at"> or
<EMAIL ADDRESS="agi@sbox.tu-graz.ac.at">. Note that I might
reply from another address, but add only one of these two to your
address book, they should be valid for a longer time.</P>

<P>If you include binary data, MIME-attachments are accepted.
Preferred archives are <CODE>.lha</CODE>, <CODE>.lzx</CODE> and
<CODE>.tar.gz</CODE>. If it is necessary, I can cope with
<EXEC>uuencode</EXEC>, but please try avoid it if possible, as I'm
awfully lazy - I always have to look at the manpage for it.</P>

<P>You can use English or German for communication, with the first
one being preferred.</P>

<P>There is no mail address as this changes too frequently.</P>

<P>As an act of protest, there also is no homepage.</P>

</WEBPAGE>
