#include <curses.h>
#include <term.h>
#define SCR_BUFFER_LEN 4096
#define LINEMAXLEN 2000

extern void x_buffch(int c);
extern char scr_buffer[SCR_BUFFER_LEN];
extern display(char x[],int pause);

/*********************************/
int (writechar)(char c)
{
unsigned int x;

x = (unsigned char) c;
x_buffch(x);
return 0;
}

/*********************************/
int get_key_str(unsigned char * p,char k[])
{
unsigned char * cp;

cp = (unsigned char *) tigetstr(k);
if (  (cp == (unsigned char *) 0)
   || (cp == (unsigned char *) -1)
   )
  {
  strcpy(p,"");
  return FALSE;
  }
else
  {
  strncpy(p,cp,LINEMAXLEN-1);
  return TRUE;
  }
}

/*********************************/
void setup()
{
setupterm( (char *) 0, 1, (int *) 0 );
}

/*********************************/
int getCOLS()
{
int i;
i = tigetnum("cols");
return i;
}

/*********************************/
int getLINES()
{
int i;
i = tigetnum("lines");
return i;
}

/*********************************/
void enter_ca()
{
tputs(enter_ca_mode,1,(int (*)(char))(writechar));
}

/*********************************/
void exit_ca()
{
tputs(exit_ca_mode,1,(int (*)(char c))(writechar));
}

/*********************************/
void insline()
{
tputs(insert_line,1,(int (*)(char c))(writechar));
}

/*********************************/
void deline()
{
tputs(delete_line,1,(int (*)(char c))(writechar));
}

/*********************************/
void clreol()
{
tputs(clr_eol,1,(int (*)(char c))(writechar));
}

/*********************************/
void clrscr()
{
tputs(clear_screen,1,(int (*)(char c))(writechar));
}

/*********************************/
void clrbot()
{
tputs(clr_eos,1,(int (*)(char c))(writechar));
}

/*********************************/
void cmove(int y, int x)
{
char * str;

if (x > getCOLS()) x = getCOLS() - 1;
if (x < 0) x = 0;
tputs(tparm(cursor_address,y,x),1,(int (*)(char c))(writechar));
}

/*********************************/
void ins_mode()
{
tputs(enter_insert_mode,1,(int (*)(char c))(writechar));
}

/*********************************/
void ovr_mode()
{
tputs(exit_insert_mode,1,(int (*)(char c))(writechar));
}

/*********************************/
void enter_bold()
{
tputs(enter_bold_mode,1,(int (*)(char c))(writechar));
}

/*********************************/
void enter_inv()
{
tputs(enter_reverse_mode,1,(int (*)(char c))(writechar));
}

/*********************************/
void enter_under()
{
tputs(enter_underline_mode,1,(int (*)(char c))(writechar));
}

/*********************************/
void exit_under()
{
tputs(exit_underline_mode,1,(int (*)(char c))(writechar));
}

/*********************************/
void enter_blink()
{
tputs(enter_blink_mode,1,(int (*)(char c))(writechar));
}

/*********************************/
void normal()
{
tputs(exit_attribute_mode,1,(int (*)(char c))(writechar));
}

/*********************************/
delchar()
{
tputs(delete_character,1,(int (*)(char c))(writechar));
}


