#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>

#include <strings.h>

#include "lists.h"
#include "wp2latex.h"
//#include "raster.h"
#include "images/ras_img.cc"

int savestruct(FILE *F,char *description, ...); //from struct.cc
string CutFileName(const char *FullFilename); //from wp2lfuti.cc

typedef struct {
	DWORD PS_unknown1;
	WORD PS_unknown2;
	WORD PS_unknown3;
       } WPGPSl1Record;

/*
typedef struct {
	DWORD FileId;
	DWORD DataOffset;
	WORD  ProductType;
	WORD  FileType;
	BYTE  MajorVersion;
	BYTE  MinorVersion;
	WORD  EncryptKey;
	} WPGHeader;

typedef struct {
	BYTE  RecType;
	DWORD RecLength;
       } WPGRecord;


static void Rd_WP_DWORD(FILE *f, DWORD *d)
{
   unsigned char b;

   fread(&b, sizeof(unsigned char), 1, f);
   *d = b;
   if(b<0xFF) return;

   fread(&b, sizeof(unsigned char), 1, f);
   *d = (DWORD)b ;
   fread(&b, sizeof(unsigned char), 1, f);
   *d += (DWORD)b * 256;
   if(*d<0x8000) return;

   *d = (*d & 0x7FFF) << 16;
   fread(&b, sizeof(unsigned char), 1, f);
   *d += (DWORD)b;
   fread(&b, sizeof(unsigned char), 1, f);
   *d += (DWORD)b * 256l;
   return;
}*/

static void Wr_WP_DWORD(FILE *f, DWORD d, char Format=0)
{
   unsigned char b;

   if(d<0xFF && Format<1)
       {
       b=d;
       fwrite(&b, 1, 1, f);
       return;
       }

  b=0xff;
  fwrite(&b, 1, 1, f);

  if(d<0x8000 && Format<2)
       {
       b = d & 255;
       fwrite(&b, 1, 1, f);
       b = d / 256;
       fwrite(&b, 1, 1, f);
       return;
       }


  b = (BYTE)((d >> 8*2) & 0x00ffl);
  fwrite( &b, 1,1,f);
  b = (BYTE)((d >> 8*3) & 0x00ffl) | 0x80;
  fwrite( &b, 1,1,f);
  b = (BYTE)((d >> 8*0) & 0x00ffl);
  fwrite( &b, 1,1,f);
  b = (BYTE)((d >> 8*1) & 0x00ffl);
  fwrite( &b, 1,1,f);
  return;
}


void PS_text(FILE *F,int x,int y,const char *Text)
{
fprintf(F,"/Times-Roman ff 375.00 scf sf\n"
	  "%d %d m\n"
	  "gs 1 -1 sc (%s) col-1 sh gr\n",x,y,Text);
}

void MakeDummyPS(TconvertedPass1 *cq, const char *Filename, const char *NewFilename)
{
FILE *PostScript;
char c1,c2;

  if((PostScript=fopen(NewFilename,"r"))!=NULL)
	{
	c1=getc(PostScript);
	c2=getc(PostScript);
	fclose(PostScript);
	if(c1=='%' && c2=='!') return;  //file already exist, do not overwrite
	}

  PostScript=fopen(NewFilename,"w");
  if(PostScript==NULL)
	{
	if (cq->err != NULL)
	       {
	       cq->perc.Hide();
	       fprintf(cq->err, _("\nWarning: Cannot write to the file %s !"),NewFilename);
	       }
	return;
	}

  fprintf(PostScript,"\
%%!PS-Adobe-2.0 EPSF-2.0\n\
%%%%Title: dummy for %s\n\
%%%%Creator: wp2latex Version %s Patchlevel 0\n\
%%%%CreationDate: %s\n\
%%%%For: wp2latex@wp2latex ()\n\
%%Magnification: 1.00\n\
%%%%Orientation: Portrait\n\
%%%%BoundingBox: 0 0 246 141\n\
%%%%Pages: 0\n\
%%%%BeginSetup\n\
%%%%IncludeFeature: *PageSize Letter\n\
%%%%EndSetup\n\
%%%%EndComments\n\
/$F2psDict 200 dict def\n\
$F2psDict begin\n\
$F2psDict /mtrx matrix put\n\
/col-1 {0 setgray} bind def\n\
\n\
end\n\
save\n\
-77.0 169.0 translate\n\
1 -1 scale\n\
\n\
/cp {closepath} bind def\n\
/gr {grestore} bind def\n\
/gs {gsave} bind def\n\
/rs {restore} bind def\n\
/l {lineto} bind def\n\
/m {moveto} bind def\n\
/n {newpath} bind def\n\
/s {stroke} bind def\n\
/sh {show} bind def\n\
/slw {setlinewidth} bind def\n\
/srgb {setrgbcolor} bind def\n\
/sc {scale} bind def\n\
/ff {findfont} bind def\n\
/sf {setfont} bind def\n\
/scf {scalefont} bind def\n\
/$F2psBegin {$F2psDict begin /$F2psEnteredState save def} def\n\
/$F2psEnd {$F2psEnteredState restore end} def\n\
%%%%EndProlog\n\
\n\
$F2psBegin\n\
10 setmiterlimit\n\
n 0 792 m 0 0 l 612 0 l 612 792 l cp clip\n\
 0.06000 0.06000 sc\n\
7.500 slw\n\
%% Polyline\n\
n 1305 495 m 5370 495 l 5370 2790 l 1305 2790 l cp gs col-1 s gr\n",
Filename,version,versiondate);

 PS_text(PostScript,1595,915,"Please convert an image");
 PS_text(PostScript,2340,1455,Filename);
 PS_text(PostScript,2115,2025,"to the postscript");
 PS_text(PostScript,2520,2550,"manually!");

 fprintf(PostScript,"$F2psEnd\n");

 fclose(PostScript);
}


void NoImgMemory(TconvertedPass1 *cq)
{
if (cq->err != NULL)
   {
   cq->perc.Hide();
   fprintf(cq->err, _("\nError: Not enough memory to store image raster!"));
   }
}


/*static int SetCategory(FILE *strip,const set & FixChars)
{
unsigned char ch;
int i=0;

if(strip==NULL) return(0);
for(ch=1;ch<255;ch++)
	{
	if(FixChars[ch])
		{
		i++;
		fprintf(strip,"\\catcode`\\%c=12\n",ch);
		}
	}
return(i);
}*/


void ImageWP(TconvertedPass1 *cq, const char *Filename, TBox & Box,
	   void (*DoCaption)(TconvertedPass1 *,unsigned short))
{
#ifdef DEBUG
  fprintf(cq->log,"\n#ImageWP(%s) ",Filename);fflush(cq->log);
#endif

DWORD ResourceEnd,NewObject,i;
char ch,NumFormat;
int lines=0;
long ldblk;
const char *ss;
string NewFilename;
string FileExtension;
FILE *SrcImage;
WPGHeader Hdr;
WPGRecord Rec;
WPG2Record Rec2;
DWORD PS_offset=0,PS_length=0;
WPG_records WPG;
WPG2Start StartWPG;
float x,y,dx,dy;
Raster2DAbstract *Raster=NULL;
APalette *Palette=NULL;
Image Img,*CurrImg;


  if(InputPS<false) return;  /* The PS image feature is disabled */

  CurrImg=&Img;
  x=y=dx=dy=0;
  if(Box.Image_type==1 && Box.Image_size>0) //WPG level 1
    {
TryWPG1:
    if(Filename==NULL) goto NoCopyImage;
    if(*Filename==0) goto NoCopyImage;
    NewFilename=OutputDir;
    NewFilename+=GetFullFileName(Filename);

    SrcImage=NULL;
    if(SaveWPG)	// make an attempt to extract resource
      {
/*	  SrcImage=fopen(NewFilename.ch,"r");
      if(SrcImage!=NULL)
	     {
	     fclose(SrcImage);
	     goto NoCopyImage;
	     }*/
      if((SrcImage=fopen(NewFilename,"wb"))==NULL) goto NoCopyImage;
      Hdr.FileId=0x435057FF;
      Hdr.DataOffset=0x10;
      Hdr.ProductType=0x1601;
      Hdr.FileType=0x1;
      Hdr.MajorVersion=0;
      Hdr.MinorVersion=0;
      Hdr.EncryptKey=0;

      savestruct(SrcImage,"ddwwbbw",
	      Hdr.FileId,Hdr.DataOffset,Hdr.ProductType,Hdr.FileType,
	      Hdr.MajorVersion,Hdr.MinorVersion,Hdr.EncryptKey);
      }

    fseek(cq->wpd,Box.Image_offset,SEEK_SET);
    cq->ActualPos=Box.Image_offset;
    ResourceEnd=Box.Image_offset+Box.Image_size; //end of resource


    while(cq->ActualPos<ResourceEnd)
	    {
	    Rec.RecType=fgetc(cq->wpd);
	    Rd_WP_DWORD(cq->wpd,&Rec.RecordLength);
	    cq->ActualPos=ftell(cq->wpd);
	    NewObject=cq->ActualPos+Rec.RecordLength;

	    NumFormat=0;
	    switch(Rec.RecType)
		    {
		    case  0x1:strcpy(cq->ObjType,"Fill Attributes"); break;
		    case  0x2:strcpy(cq->ObjType,"Line Attributes"); break;
		    case  0x3:strcpy(cq->ObjType,"Symbol Attributes"); break;
		    case  0x4:strcpy(cq->ObjType,"Polysymbol"); break;
		    case  0x5:strcpy(cq->ObjType,"Line"); break;
		    case  0x6:strcpy(cq->ObjType,"Curve"); break;
		    case  0x7:strcpy(cq->ObjType,"Rectangle"); break;
		    case  0x8:strcpy(cq->ObjType,"Polygon"); break;
		    case  0x9:strcpy(cq->ObjType,"Elipsis"); break;
		    case  0xA:strcpy(cq->ObjType,"Elipsis"); break;
		    case  0xB:strcpy(cq->ObjType,"Bitmap l1");
			      LoadWPGBitmapType1(cq->wpd,WPG.BitmapType1);
			      if(Raster!=NULL) break;
			      Raster=CreateRaster2D(WPG.BitmapType1.Width,WPG.BitmapType1.Height,WPG.BitmapType1.Depth);

LoadRaster:                   if(Raster==NULL) {NoImgMemory(cq);break;}
			      if(UnpackWPGRaster(Raster,cq->wpd)<0)
					{delete Raster;Raster=NULL;break;}

			      if(Img.Raster!=NULL)
				{
				CurrImg->Next=new Image;
				CurrImg=CurrImg->Next;
				}
			      CurrImg->x=x;
			      CurrImg->y=y;
			      CurrImg->dx=dx;
			      CurrImg->dy=dy;
			      x=y=dx=dy=0;
			      CurrImg->Raster=Raster;CurrImg->Raster->UsageCount++;Raster=NULL;
			      if(Palette!=NULL)
				{
				if(CurrImg->Raster->GetPlanes()==1 &&
				    (Palette->GetValue1D(0)==0 && Palette->GetValue1D(1)==0 && Palette->GetValue1D(2)==0 &&
				     Palette->GetValue1D(3)==0 && Palette->GetValue1D(4)==0 && Palette->GetValue1D(5)==0))
				      CurrImg->Palette=NULL;
				else {CurrImg->Palette=Palette;CurrImg->Palette->UsageCount++;}
				}
			      break;
		    case  0xC:strcpy(cq->ObjType,"Graphics Text");NumFormat=1; break; //This is a bug fix for Draw Perfect WPG
		    case  0xD:strcpy(cq->ObjType,"Text Attributes"); break;
		    case  0xE:strcpy(cq->ObjType,"Color Map");
			      LoadWPGColormap(cq->wpd,WPG.ColorMapRec);
			      if(Palette!=NULL && Palette->UsageCount==0) delete Palette;
			      Palette=BuildPalette(WPG.ColorMapRec.NumOfEntries+WPG.ColorMapRec.StartIndex,8);
			      if(Palette!=NULL)
				 {
				 fread((char *)Palette->Data1D + 3*WPG.ColorMapRec.StartIndex,
					3*WPG.ColorMapRec.NumOfEntries,1,cq->wpd);
				 if(GrayPalette(Palette,Raster==NULL?0:Raster->GetPlanes()))
					{
					delete Palette;
					Palette=NULL;
					}
				  }
			      break;	// NumFormat=1; // default DR
		    case  0xF:strcpy(cq->ObjType,"Start WPG l1"); break;
		    case 0x10:strcpy(cq->ObjType,"End WPG l1"); break;
		    case 0x11:strcpy(cq->ObjType,"Start PS l1");
			      if(Rec.RecordLength>8)
				{
				PS_offset=cq->ActualPos+8;   /*skip PS header in the wpg*/
				PS_length=Rec.RecordLength-8;
				}
			      break;
		    case 0x12:strcpy(cq->ObjType,"Output Attributes"); break;
		    case 0x13:strcpy(cq->ObjType,"Plain Curve"); break;
		    case 0x14:strcpy(cq->ObjType,"Bitmap l2");
			      LoadWPGBitmapType2(cq->wpd,WPG.BitmapType2);
			      if(Raster!=NULL) break;
			      Raster=CreateRaster2D(WPG.BitmapType2.Width,WPG.BitmapType2.Height,WPG.BitmapType2.Depth);
			      if(Raster==NULL) {NoImgMemory(cq);break;}
			      x=WPG.BitmapType2.LowLeftX/47.0;
			      y=WPG.BitmapType2.LowLeftY/47.0;
			      dx=(WPG.BitmapType2.UpRightX-WPG.BitmapType2.LowLeftX)/47.0;
			      dy=(WPG.BitmapType2.UpRightY-WPG.BitmapType2.LowLeftY)/47.0;
			      goto LoadRaster;
		    case 0x15:strcpy(cq->ObjType,"Start Image"); break;
		    case 0x16:strcpy(cq->ObjType,"Start Graph"); break;
		    case 0x17:strcpy(cq->ObjType,"Plan Perfect"); break;
		    case 0x18:strcpy(cq->ObjType,"Graphics Text l2"); break; // NumFormat=1; // default DR
		    case 0x19:strcpy(cq->ObjType,"Data Start l2");  break;
		    case 0x1A:strcpy(cq->ObjType,"Graphics Text l3"); break;
		    case 0x1B:strcpy(cq->ObjType,"Postscript l2");
			      if(Rec.RecordLength>0x3B)
				{
				PS_offset=cq->ActualPos+0x3C;   /*skip PS l2 header in the wpg*/
				PS_length=Rec.RecordLength-0x3C;
				}
			      break;
		    default: sprintf(cq->ObjType,"?%d?",(int)Rec.RecType); break;
		    }

//Save WPG to the disk file
	    if(SrcImage)
	      {
	      fseek(cq->wpd,cq->ActualPos,SEEK_SET);
	      fputc(Rec.RecType,SrcImage);
	      Wr_WP_DWORD(SrcImage, Rec.RecordLength, NumFormat);
	      for(i=0;i<Rec.RecordLength;i++)
		      {
		      ch=fgetc(cq->wpd);
		      fputc(ch,SrcImage);
		      }
	      }

//Log a graphical image object into report
	    if(cq->log!=NULL)
		    {
		    fprintf(cq->log,"\n%*s{GRtyp#%X;len:%lx;%s}",cq->recursion * 2, "",
		       (int)Rec.RecType,(long)Rec.RecordLength,cq->ObjType);
		    }

	    if(NewObject!=ftell(cq->wpd))
		    fseek(cq->wpd,NewObject,SEEK_SET);
	    cq->ActualPos=NewObject;
	    } /**/

    if(SrcImage) fclose(SrcImage);
    }

  if(Box.Image_type==2 && Box.Image_size>0) //WPG level 2
    {
    if(Filename==NULL) goto NoCopyImage;
    if(*Filename==0) goto NoCopyImage;
    NewFilename=OutputDir;
    NewFilename+=GetFullFileName(Filename);

    fseek(cq->wpd,Box.Image_offset,SEEK_SET);
    ResourceEnd=Box.Image_offset+Box.Image_size; //end of resource

    loadstruct(cq->wpd,"ddwwbbw",
	      &Hdr.FileId,&Hdr.DataOffset,&Hdr.ProductType,&Hdr.FileType,
	      &Hdr.MajorVersion,&Hdr.MinorVersion,&Hdr.EncryptKey);
    if(Hdr.FileId!=0x435057FF || (Hdr.ProductType>>8)!=0x16 ||
       Hdr.EncryptKey!=0)
	 goto NoCopyImage;
    if(Hdr.FileType==1)  /*WPG level 1 with header*/
	{
	Box.Image_offset+=Hdr.DataOffset;
	Box.Image_size-=Hdr.DataOffset;
	if(Box.Image_size>0) goto TryWPG1;
	}
    if(Hdr.FileType!=2) goto NoCopyImage;

    if(SaveWPG)	// make an attempt to extract resource
      {
/*	  SrcImage=fopen(NewFilename.ch,"r");
      if(SrcImage!=NULL)
	     {
	     fclose(SrcImage);
	     goto NoCopyImage;
	     }*/
      if((SrcImage=fopen(NewFilename,"wb"))==NULL) goto NoCopyImage;
      fseek(cq->wpd,Box.Image_offset,SEEK_SET);
      for(i=0;i<Box.Image_size;i++)
		      {
		      ch=fgetc(cq->wpd);
		      fputc(ch,SrcImage);
		      }
      fclose(SrcImage);
      }


    fseek(cq->wpd,Box.Image_offset+Hdr.DataOffset,SEEK_SET);
    cq->ActualPos=Box.Image_offset+Hdr.DataOffset;
    StartWPG.PosSizePrecision=0;

    while(cq->ActualPos<ResourceEnd)
	    {
	    Rec2.Class=fgetc(cq->wpd);
	    Rec2.Type=fgetc(cq->wpd);
	    Rd_WP_DWORD(cq->wpd,&Rec2.Extension);
	    Rd_WP_DWORD(cq->wpd,&Rec2.RecordLength);
	    cq->ActualPos=ftell(cq->wpd);
	    NewObject=cq->ActualPos+Rec2.RecordLength;

	    if(feof(cq->wpd)) break;

	    switch(Rec2.Type)
		{
		case 0x1:strcpy(cq->ObjType,"Start WPG");
			 LoadWPG2Start(cq->wpd,StartWPG);
			 break;
		case 0x2:strcpy(cq->ObjType,"End WPG"); break;
		case 0x3:strcpy(cq->ObjType,"Form Settings"); break;
		case 0x4:strcpy(cq->ObjType,"Ruller Settings"); break;
		case 0x5:strcpy(cq->ObjType,"Grid Settings"); break;
		case 0x6:strcpy(cq->ObjType,"Layer"); break;
		case 0x7:strcpy(cq->ObjType,"Object Link"); break;
		case 0x8:strcpy(cq->ObjType,"Pen style definition"); break;
		case 0x9:strcpy(cq->ObjType,"Pattern Definition"); break;
		case 0xA:strcpy(cq->ObjType,"Comment"); break;
		case 0x0B:strcpy(cq->ObjType,"Color Transfer"); break;
		case 0x0C:strcpy(cq->ObjType,"Color Palette");
			  LoadWPGColormap(cq->wpd,WPG.ColorMapRec);
			  if(Palette!=NULL && Palette->UsageCount==0) delete Palette;
			  Palette=BuildPalette(WPG.ColorMapRec.NumOfEntries+WPG.ColorMapRec.StartIndex,8);
			  if(Palette!=NULL)
			     {
			     for(i=WPG.ColorMapRec.StartIndex;i<WPG.ColorMapRec.NumOfEntries;i++)
				 {
				 Palette->SetValue1D(3*i,fgetc(cq->wpd));
				 Palette->SetValue1D(3*i+1,fgetc(cq->wpd));
				 Palette->SetValue1D(3*i+2,fgetc(cq->wpd));
				 fgetc(cq->wpd);//Opacity?
				 }
			     if(GrayPalette(Palette,Raster==NULL?0:Raster->GetPlanes()))
				 {
				 delete Palette;
				 Palette=NULL;
				 }
			     }
			  break;
		case 0x0D:strcpy(cq->ObjType,"DP Color Palette"); break;
		case 0x0E:strcpy(cq->ObjType,"Bitmap Data");
		   LoadWPG2BitmapData(cq->wpd,WPG._2BitmapData);
		   if(WPG._2BitmapData.Compression>1) goto Skip_WP_BMP;
		   switch(WPG._2BitmapData.Depth)
		     {
		     case 1:i=1;break;
		     case 2:i=2;break;
		     case 3:i=4;break;
		     case 4:i=8;break;
		     case 8:i=24;break;
		     default:goto Skip_WP_BMP;  /*Ignore raster with unknown depth*/
		     }
		   Raster=CreateRaster2D(WPG._2BitmapData.Width,WPG._2BitmapData.Height,i);
		   if(Raster==NULL) {NoImgMemory(cq);goto Skip_WP_BMP;}

		   if(WPG._2BitmapData.Compression==1)
		     {
		     if(UnpackWPG2Raster(Raster,cq->wpd)<0)
				  Raster->Erase();
		     }
		   if(WPG._2BitmapData.Compression==0)
		     {
		     ldblk=(Raster->GetPlanes()*Raster->Size1D+7)/8;
		     for(i=0;i<Raster->Size2D;i++)
		       {
		       if(fread(Raster->GetRow(i),ldblk,1,cq->wpd)!=1) break;
	      //	AlineProc(i,p);
		       }
		     }
		   if(Img.Raster!=NULL)
			 {
			 CurrImg->Next=new Image;
			 CurrImg=CurrImg->Next;
			 }
		   CurrImg->x=x;
		   CurrImg->y=y;
		   CurrImg->dx=dx;
		   CurrImg->dy=dy;
		   x=y=dx=dy=0;
		   if(Raster!=NULL) {CurrImg->Raster=Raster;CurrImg->Raster->UsageCount++;Raster=NULL;}
		   if(Palette!=NULL){CurrImg->Palette=Palette;CurrImg->Palette->UsageCount++;}
		   break;
		case 0x0F:strcpy(cq->ObjType,"Text Data");break;
		case 0x10:strcpy(cq->ObjType,"Chart Style");break;
		case 0x11:strcpy(cq->ObjType,"Chart Data");break;
		case 0x12:		//Blbe!!!!!!! Opravit!!!!!
		   strcpy(cq->ObjType,"Object Image"); /* Postscript WPG2*/
		   if(Rec2.RecordLength>0x12)
			{
			PS_offset=cq->ActualPos+0x12;   /*skip PS header in the wpg2*/
			PS_length=Rec2.RecordLength-0x12;
			}
		   break;

		case 0x15:strcpy(cq->ObjType,"Polyline");break;
		case 0x16:strcpy(cq->ObjType,"Polyspline");break;
		case 0x17:strcpy(cq->ObjType,"Polycurve");break;
		case 0x18:strcpy(cq->ObjType,"Rectangle");break;
		case 0x19:strcpy(cq->ObjType,"Arc");break;
		case 0x1A:strcpy(cq->ObjType,"Compound Polygon");break;
		case 0x1B:strcpy(cq->ObjType,"Bitmap position");
			  if(StartWPG.PosSizePrecision==0)
			     {
			     LoadWPG2BitmapRectangle(cq->wpd,WPG._2BitmapRectangle);
			     x=WPG._2BitmapRectangle.LowLeftX/47.0;
			     y=WPG._2BitmapRectangle.LowLeftY/47.0;
			     dx=(WPG._2BitmapRectangle.UpRightX-WPG._2BitmapRectangle.LowLeftX)/47.0;
			     dy=(WPG._2BitmapRectangle.UpRightY-WPG._2BitmapRectangle.LowLeftY)/47.0;
			     break;
			     }
			  if(StartWPG.PosSizePrecision==1)
			     {
			     LoadWPG2DblBitmapRectangle(cq->wpd,WPG._2DblBitmapRectangle);
			     x=WPG._2DblBitmapRectangle.LowLeftX/(47.0*0xFFFF);
			     y=WPG._2DblBitmapRectangle.LowLeftY/(47.0*0xFFFF);
			     dx=(WPG._2DblBitmapRectangle.UpRightX-WPG._2DblBitmapRectangle.LowLeftX)/(47.0*0xFFFF);
			     dy=(WPG._2DblBitmapRectangle.UpRightY-WPG._2DblBitmapRectangle.LowLeftY)/(47.0*0xFFFF);
			     break;
			     }
			  break;
		case 0x1C:strcpy(cq->ObjType,"Text Line");break;
		case 0x1D:strcpy(cq->ObjType,"Text Block");break;
		case 0x1E:strcpy(cq->ObjType,"Text Path");break;
		case 0x1F:strcpy(cq->ObjType,"Chart");break;
		case 0x20:strcpy(cq->ObjType,"Group");break;
		case 0x21:strcpy(cq->ObjType,"Object Capsule");break;
		case 0x22:strcpy(cq->ObjType,"Font Settings");break;
		case 0x23:strcpy(cq->ObjType,"Line Cap Definition");break;
		case 0x24:strcpy(cq->ObjType,"Line Join Definition");break;
		case 0x25:strcpy(cq->ObjType,"Pen Fore Color");break;
		case 0x26:strcpy(cq->ObjType,"DP Pen Fore Color");break;
		case 0x27:strcpy(cq->ObjType,"Pen Back Color");break;
		case 0x28:strcpy(cq->ObjType,"DP Pen Back Color");break;
		case 0x29:strcpy(cq->ObjType,"Pen Style");break;
		case 0x2A:strcpy(cq->ObjType,"Pen Pattern");break;
		case 0x2B:strcpy(cq->ObjType,"Pen Size");break;
		case 0x2C:strcpy(cq->ObjType,"DP Pen Size");break;
		case 0x2D:strcpy(cq->ObjType,"Line Cap");break;
		case 0x2E:strcpy(cq->ObjType,"Line Join");break;
		case 0x2F:strcpy(cq->ObjType,"Brush Gradient");break;
		case 0x30:strcpy(cq->ObjType,"DP Brush Gradient");break;
		case 0x31:strcpy(cq->ObjType,"Brush Fore Color");break;
		case 0x32:strcpy(cq->ObjType,"DP Brush Fore Color");break;
		case 0x33:strcpy(cq->ObjType,"Brush Back Color");break;
		case 0x34:strcpy(cq->ObjType,"DP Brush Back Color");break;
		case 0x35:strcpy(cq->ObjType,"Brush Pattern");break;
		case 0x36:strcpy(cq->ObjType,"Horizontal Line");break;
		case 0x37:strcpy(cq->ObjType,"Vertical Line");break;
		case 0x38:strcpy(cq->ObjType,"Poster Settings");break;
		case 0x39:strcpy(cq->ObjType,"Image State");break;
		case 0x3A:strcpy(cq->ObjType,"Envelope Definition");break;
		case 0x3B:strcpy(cq->ObjType,"Envelope");break;
		case 0x3C:strcpy(cq->ObjType,"Texture Definition");break;
		case 0x3D:strcpy(cq->ObjType,"Brush Texture");break;
		case 0x3E:strcpy(cq->ObjType,"Texture Alignment");break;
		case 0x3F:strcpy(cq->ObjType,"Pen Texture");break;

		default: sprintf(cq->ObjType,"?%d?",(int)Rec2.Type); break;
		}
Skip_WP_BMP:

//Log a graphical image object into report
	    if(cq->log!=NULL)
		    {
		    fprintf(cq->log,"\n%*s{GRtyp#%X;len:%lx;%s}",cq->recursion * 2, "",
		       (int)Rec2.Type,(long)Rec2.RecordLength,cq->ObjType);
		    }

	    if(NewObject!=ftell(cq->wpd))
		    fseek(cq->wpd,NewObject,SEEK_SET);
	    cq->ActualPos=NewObject;
	    }
    }
if(Palette!=NULL && Palette->UsageCount==0) {delete Palette;Palette=NULL;}
if(Raster!=NULL && Raster->UsageCount==0) {delete Raster;Raster=NULL;}

NoCopyImage:
  ss=GetExtension(Filename);
  if(ss!=NULL) if(*ss!=0) FileExtension=ToUpper(ss+1);

  NewFilename=OutputDir+CutFileName(Filename)+".eps";
  if(NewFilename!="")
    for(i=StrLen(OutputDir);i<length(NewFilename);i++)
	{
	if(NewFilename[i]==' ' || NewFilename[i]=='#' || NewFilename[i]=='%' || NewFilename[i]=='$')
		{
		if (cq->err != NULL)
		  {
		  cq->perc.Hide();
		  fprintf(cq->err, _("\nWarning: LaTeX cannot process filenames that contains '%c'-> fixed to '_'!"),NewFilename[i]);
		  }
		NewFilename[i]='_';
		}
	}


  if(FileExtension=="PS" || FileExtension=="EPS")
     {			// Chybi verifikace na ps!!!!!!!
     if(AbsolutePath(Filename))
	{
	if(!CopyFile(NewFilename,Filename)) goto FileIsOK;
	}
     else
	{
	for(i=0;i<length(ImgInputDirs);i++)
	  {
	  if(!CopyFile(NewFilename,(string(ImgInputDirs[i])+Filename)())) goto FileIsOK;
	  }
	}
     }

  if(Img.Raster!=NULL)  /*Convert raster image into the postscript*/
	{
SavePS:	SavePictureEPS(NewFilename(),Img);
	goto FileIsOK;
	}

  if(PS_offset>8 && PS_length>0) /*Try to extract PS part from wpg metafile*/
	{
	if( (SrcImage=fopen(NewFilename,"wb"))!=NULL )
	  {
	  fseek(cq->wpd,PS_offset,SEEK_SET);
	  while (PS_length-->0)
	     fputc(fgetc(cq->wpd), SrcImage); /*Copy all PS contents*/

	  fclose(SrcImage);
	  goto FileIsOK;
	  }
	}

/*Try to load image from external file*/
  for(i=0;i<length(ImgInputDirs);i++)
	{
	Img=LoadPicture((string(ImgInputDirs[i])+Filename)());
	if(Img.Raster!=NULL) goto SavePS;
	}


  MakeDummyPS(cq, Filename, NewFilename);


FileIsOK:
  NewFilename=CutFileName(NewFilename); 	//New Filename only

  if(cq->char_on_line == -20)    /* Left one enpty line for new enviroment */
	  {
	  fputc('%', cq->strip);
	  NewLine(cq);
	  cq->char_on_line = true;
	  }
  if (cq->char_on_line==true)    /* make new line for leader of minipage */
	 {
	 putc('\n', cq->strip);
	 cq->line_term = 's';   /* Soft return */
	 Make_tableentry_envir_extra_end(cq);

	 cq->nomore_valid_tabs = false;
	 cq->rownum++;
	 Make_tableentry_attr(cq);
	 cq->latex_tabpos = 0;
	 }


  if(cq->flag == HeaderText) Box.AnchorType=2;

//This writes a TeX program for including an image into the document
  InputPS|=1;
  if(Box.AnchorType!=2)
	{
	if(!BoxTexHeader(cq, Box)) Box.CaptionSize=0;
	putc('\n',cq->strip); lines++;
	}

  if(InputPS & 2)	//graphics.sty
    {
    if(Box.AnchorType!=2) fprintf(cq->strip," \\begin{center}");
    fprintf(cq->strip,"\\includegraphics");
    switch(Box.HorizontalPos)
	{
	case 4:if(Box.Width!=100)
		   {
		   fprintf(cq->strip,"[width=%2.2f\\textwidth]",Box.Width/100);break;
		   }
	case 3:fprintf(cq->strip,"[width=\\textwidth]");break;
	default:fprintf(cq->strip,"[width=%2.2fcm]",Box.Width/10.0);
	}
    fprintf(cq->strip,"{%s.eps}",NewFilename() );
    if(Box.AnchorType!=2) fprintf(cq->strip," \\end{center}");
    putc('\n',cq->strip); lines++;
    }
  else if(InputPS & 4)	//epsfig.sty
    {
    if(Box.AnchorType!=2) fprintf(cq->strip," \\begin{center}");
    fprintf(cq->strip,"\\epsfig{file=\\FigDir/%s.eps,",NewFilename() );
    switch(Box.HorizontalPos)
	{
	case 4:if(Box.Width!=100)
		   {
		   fprintf(cq->strip,"width=%2.2f\\textwidth",Box.Width/100);break;
		   }
	case 3:fprintf(cq->strip,"width=\\textwidth");break;
	default:fprintf(cq->strip,"width=%2.2fcm",Box.Width/10.0);
	}
    putc('}',cq->strip);
    if(Box.AnchorType!=2) fprintf(cq->strip," \\end{center}");
    putc('\n',cq->strip); lines++;
    }
  else			//InputPS.sty
    {
    fprintf(cq->strip,"\\begin{forcewidth}");
    switch(Box.HorizontalPos)
	{
	case 4:if(Box.Width!=100)
		   {
		   fprintf(cq->strip,"{%2.2f\\textwidth}\n",Box.Width/100);break;
		   }
	case 3:fprintf(cq->strip,"{\\textwidth}\n");break;
	default:fprintf(cq->strip,"{%2.2fcm}\n",Box.Width/10);
	}
    lines++;
    if(Box.AnchorType!=2) fprintf(cq->strip," \\begin{center}");
    fprintf(cq->strip,"\\InputPS{\\FigDir/%s.eps}",NewFilename() );
    if(Box.AnchorType!=2) fprintf(cq->strip," \\end{center}");
    putc('\n',cq->strip); lines++;
    fprintf(cq->strip,"\\end{forcewidth}\n");lines++;
    }

  if(Box.CaptionSize>0 && Box.CaptionPos>0 && Box.AnchorType!=2 && DoCaption)
	{
	fseek(cq->wpd,Box.CaptionPos,SEEK_SET);
	DoCaption(cq,Box.CaptionSize);
	}

  if(Box.AnchorType!=2)
	{
	BoxTexFoot(cq, Box);
	fprintf(cq->strip,"\n");
	lines++;
	}

  while(lines>0)
     {
     cq->line_term = 's';   /* Soft return */
     Make_tableentry_envir_extra_end(cq);
     cq->char_on_line = false;
     cq->nomore_valid_tabs = false;
     cq->rownum++;
     Make_tableentry_attr(cq);
     cq->latex_tabpos = 0;

     lines--;
     }

  cq->char_on_line = false;
}


